How to use Wait functionality to validatewhether a key does not exist in a S3 bucket in Boto3?

Boto3PythonServer Side ProgrammingProgramming

Problem Statement − Use boto3 library in Python to check whether a key does not exist in a bucket, using waiters functionality. For example, use waiters to check whether a key test1.zip does not exist in Bucket_1.

Approach/Algorithm to solve this problem

Step 1 − Import boto3 and botocore exceptions to handle exceptions.

Step 2 − bucket_name and key are two parameters in function.

Step 3 − Create an AWS session using boto3 library.

Step 4 − Create an AWS client for S3.

Step 5 − Now create the wait object for object_not_exists using get_waiter function

Step 6 − Now, use the wait object to validate whether key does not exist in a given bucket. By default, it checks in every 5 seconds until a successful state is reached. An error is returned after 20 failed checks. However, user can define polling time and max attempts.

Step 7 − It returns None.

Step 8 − Handle the generic exception if something went wrong while checking the bucket.

Example

Use the following code to use waiter to check whether key exists in a bucket or not −

import boto3
from botocore.exceptions import ClientError

def use_waiters_check_object_not_exists(bucket_name, key_name):
   session = boto3.session.Session()
   s3_client = session.client('s3')
   try:
      waiter = s3_client.get_waiter('object_not_exists')
      waiter.wait(Bucket=bucket_name, Key = key_name,
                  WaiterConfig={
                     'Delay': 2, 'MaxAttempts': 5})
      print('Object does not exist: ' + bucket_name +'/'+key_name)
   except ClientError as e:
      raise Exception( "boto3 client error in use_waiters_check_object_not_exists: " + e.__str__())
   except Exception as e:
      raise Exception( "Unexpected error in use_waiters_check_object_not_exists: " + e.__str__())

print(use_waiters_check_object_exists("Bucket_1","testfolder/test1.zip"))
print(use_waiters_check_object_exists("Bucket_1","testfolder/test.zip"))

Output

Object does not exist: Bucket_1/testfolder/test1.zip
None

botocore.exceptions.WaiterError: Waiter ObjectNotExists failed: Max attempts exceeded
"Unexpected error in use_waiters_check_object_not_exists: " + e.__str__())
Exception: Unexpected error in use_waiters_check_object_not_exists:
Waiter ObjectNotExists failed: Max attempts exceed

For Bucket_1/testfolder/test1.zip, the output is print statement and None. Since the response doesn’t return anything, it prints None.

For Bucket_1/testfolder/test.zip, the output is an exception since this object exists.

In exception, it can be read that Max attempts exceeded.

raja
Published on 22-Mar-2021 08:13:24

Advertisements